]> git.ipfire.org Git - thirdparty/git.git/blame - git-bisect.sh
git-svn: Make it incrementally faster by minimizing temp files
[thirdparty/git.git] / git-bisect.sh
CommitLineData
8cc6a083 1#!/bin/sh
d025524d 2
243a60fb
CC
3USAGE='[help|start|bad|good|skip|next|reset|visualize|replay|log|run]'
4LONG_USAGE='git bisect help
5 print this long help message.
6git bisect start [<bad> [<good>...]] [--] [<pathspec>...]
38a47fd6
CC
7 reset bisect state and start bisection.
8git bisect bad [<rev>]
9 mark <rev> a known-bad revision.
10git bisect good [<rev>...]
11 mark <rev>... known-good revisions.
6ca8b977
CC
12git bisect skip [<rev>...]
13 mark <rev>... untestable revisions.
38a47fd6
CC
14git bisect next
15 find next bisection to test and check it out.
16git bisect reset [<branch>]
17 finish bisection search and go back to branch.
18git bisect visualize
19 show bisect status in gitk.
20git bisect replay <logfile>
21 replay bisection log.
22git bisect log
23 show bisect log.
24git bisect run <cmd>...
243a60fb
CC
25 use <cmd>... to automatically bisect.
26
27Please use "git help bisect" to get the full man page.'
d025524d 28
8f321a39 29OPTIONS_SPEC=
ae2b0f15 30. git-sh-setup
4c550686 31require_work_tree
8cc6a083 32
ce32660e
JS
33_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
34_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
35
e9a45d75 36sq() {
d9bffc08 37 @@PERL@@ -e '
e9a45d75
JH
38 for (@ARGV) {
39 s/'\''/'\'\\\\\'\''/g;
40 print " '\''$_'\''";
41 }
42 print "\n";
43 ' "$@"
44}
45
8cc6a083 46bisect_autostart() {
823ea121 47 test -s "$GIT_DIR/BISECT_START" || {
8cc6a083
LT
48 echo >&2 'You need to start by "git bisect start"'
49 if test -t 0
50 then
51 echo >&2 -n 'Do you want me to do it for you [Y/n]? '
52 read yesno
53 case "$yesno" in
54 [Nn]*)
55 exit ;;
56 esac
57 bisect_start
58 else
59 exit 1
60 fi
61 }
62}
63
64bisect_start() {
8cc6a083 65 #
634f2464 66 # Verify HEAD.
8cc6a083 67 #
48949a18 68 head=$(GIT_DIR="$GIT_DIR" git symbolic-ref -q HEAD) ||
ce32660e
JS
69 head=$(GIT_DIR="$GIT_DIR" git rev-parse --verify HEAD) ||
70 die "Bad HEAD - I need a HEAD"
634f2464 71
ee831f7d 72 #
634f2464 73 # Check if we are bisecting.
ee831f7d 74 #
d3e54c88 75 start_head=''
634f2464
CC
76 if test -s "$GIT_DIR/BISECT_START"
77 then
78 # Reset to the rev from where we started.
9d0cd91c
CC
79 start_head=$(cat "$GIT_DIR/BISECT_START")
80 git checkout "$start_head" || exit
634f2464
CC
81 else
82 # Get rev from where we start.
83 case "$head" in
84 refs/heads/*|$_x40)
85 # This error message should only be triggered by
86 # cogito usage, and cogito users should understand
87 # it relates to cg-seek.
88 [ -s "$GIT_DIR/head-name" ] &&
89 die "won't bisect on seeked tree"
90 start_head="${head#refs/heads/}"
91 ;;
92 *)
93 die "Bad HEAD - strange symbolic ref"
94 ;;
95 esac
96 fi
8cc6a083
LT
97
98 #
634f2464 99 # Get rid of any old bisect state.
8cc6a083 100 #
823ea121 101 bisect_clean_state || exit
38a47fd6
CC
102
103 #
104 # Check for one bad and then some good revisions.
105 #
106 has_double_dash=0
107 for arg; do
108 case "$arg" in --) has_double_dash=1; break ;; esac
109 done
110 orig_args=$(sq "$@")
111 bad_seen=0
d3e54c88 112 eval=''
38a47fd6
CC
113 while [ $# -gt 0 ]; do
114 arg="$1"
115 case "$arg" in
116 --)
8fe26f44 117 shift
38a47fd6
CC
118 break
119 ;;
120 *)
634f2464 121 rev=$(git rev-parse -q --verify "$arg^{commit}") || {
38a47fd6
CC
122 test $has_double_dash -eq 1 &&
123 die "'$arg' does not appear to be a valid revision"
124 break
125 }
737c74ee
CC
126 case $bad_seen in
127 0) state='bad' ; bad_seen=1 ;;
128 *) state='good' ;;
129 esac
d3e54c88 130 eval="$eval bisect_write '$state' '$rev' 'nolog'; "
8fe26f44 131 shift
38a47fd6
CC
132 ;;
133 esac
8fe26f44 134 done
38a47fd6 135
ba963de8
CC
136 #
137 # Change state.
138 # In case of mistaken revs or checkout error, or signals received,
139 # "bisect_auto_next" below may exit or misbehave.
140 # We have to trap this to be able to clean up using
141 # "bisect_clean_state".
142 #
143 trap 'bisect_clean_state' 0
144 trap 'exit 255' 1 2 3 15
145
146 #
147 # Write new start state.
148 #
ba963de8 149 echo "$start_head" >"$GIT_DIR/BISECT_START" &&
823ea121 150 sq "$@" >"$GIT_DIR/BISECT_NAMES" &&
ba963de8 151 eval "$eval" &&
6c98c054 152 echo "git bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG" || exit
ba963de8
CC
153 #
154 # Check if we can proceed to the next bisect state.
155 #
38a47fd6 156 bisect_auto_next
ba963de8
CC
157
158 trap '-' 0
8cc6a083
LT
159}
160
55624f9a
CC
161bisect_write() {
162 state="$1"
163 rev="$2"
737c74ee 164 nolog="$3"
55624f9a
CC
165 case "$state" in
166 bad) tag="$state" ;;
167 good|skip) tag="$state"-"$rev" ;;
168 *) die "Bad bisect_write argument: $state" ;;
169 esac
ba963de8 170 git update-ref "refs/bisect/$tag" "$rev" || exit
f454cdc4 171 echo "# $state: $(git show-branch $rev)" >>"$GIT_DIR/BISECT_LOG"
6c98c054 172 test -n "$nolog" || echo "git bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
55624f9a
CC
173}
174
155fc795 175bisect_state() {
8cc6a083 176 bisect_autostart
155fc795
CC
177 state=$1
178 case "$#,$state" in
179 0,*)
180 die "Please call 'bisect_state' with at least one argument." ;;
181 1,bad|1,good|1,skip)
182 rev=$(git rev-parse --verify HEAD) ||
183 die "Bad rev input: HEAD"
184 bisect_write "$state" "$rev" ;;
e3389075 185 2,bad|*,good|*,skip)
155fc795 186 shift
d3e54c88 187 eval=''
e3389075 188 for rev in "$@"
155fc795 189 do
a179a303 190 sha=$(git rev-parse --verify "$rev^{commit}") ||
e3389075 191 die "Bad rev input: $rev"
d3e54c88
CC
192 eval="$eval bisect_write '$state' '$sha'; "
193 done
194 eval "$eval" ;;
e3389075
CC
195 *,bad)
196 die "'git bisect bad' can take only one argument." ;;
cc9f24d0
JH
197 *)
198 usage ;;
8cc6a083 199 esac
97e1c51e
CC
200 bisect_auto_next
201}
202
8cc6a083 203bisect_next_check() {
0a5280a9
JH
204 missing_good= missing_bad=
205 git show-ref -q --verify refs/bisect/bad || missing_bad=t
206 test -n "$(git for-each-ref "refs/bisect/good-*")" || missing_good=t
6fecf191 207
0a5280a9
JH
208 case "$missing_good,$missing_bad,$1" in
209 ,,*)
210 : have both good and bad - ok
211 ;;
212 *,)
213 # do not have both but not asked to fail - just report.
214 false
215 ;;
216 t,,good)
217 # have bad but not good. we could bisect although
218 # this is less optimum.
219 echo >&2 'Warning: bisecting only with a bad commit.'
220 if test -t 0
221 then
222 printf >&2 'Are you sure [Y/n]? '
e5d3afd7
FM
223 read yesno
224 case "$yesno" in [Nn]*) exit 1 ;; esac
0a5280a9
JH
225 fi
226 : bisect without good...
227 ;;
8cc6a083 228 *)
0a5280a9 229 THEN=''
823ea121 230 test -s "$GIT_DIR/BISECT_START" || {
0a5280a9
JH
231 echo >&2 'You need to start by "git bisect start".'
232 THEN='then '
233 }
234 echo >&2 'You '$THEN'need to give me at least one good' \
235 'and one bad revisions.'
236 echo >&2 '(You can use "git bisect bad" and' \
237 '"git bisect good" for that.)'
238 exit 1 ;;
8cc6a083
LT
239 esac
240}
241
242bisect_auto_next() {
434d036f 243 bisect_next_check && bisect_next || :
8cc6a083
LT
244}
245
42ba5ee7
CC
246eval_rev_list() {
247 _eval="$1"
248
249 eval $_eval
250 res=$?
251
252 if [ $res -ne 0 ]; then
253 echo >&2 "'git rev-list --bisect-vars' failed:"
254 echo >&2 "maybe you mistake good and bad revs?"
255 exit $res
256 fi
257
258 return $res
259}
260
97e1c51e
CC
261filter_skipped() {
262 _eval="$1"
263 _skip="$2"
264
265 if [ -z "$_skip" ]; then
42ba5ee7 266 eval_rev_list "$_eval"
97e1c51e
CC
267 return
268 fi
269
270 # Let's parse the output of:
271 # "git rev-list --bisect-vars --bisect-all ..."
42ba5ee7 272 eval_rev_list "$_eval" | while read hash line
97e1c51e
CC
273 do
274 case "$VARS,$FOUND,$TRIED,$hash" in
275 # We display some vars.
276 1,*,*,*) echo "$hash $line" ;;
277
278 # Split line.
279 ,*,*,---*) ;;
280
281 # We had nothing to search.
282 ,,,bisect_rev*)
283 echo "bisect_rev="
284 VARS=1
285 ;;
286
287 # We did not find a good bisect rev.
288 # This should happen only if the "bad"
289 # commit is also a "skip" commit.
290 ,,*,bisect_rev*)
291 echo "bisect_rev=$TRIED"
292 VARS=1
293 ;;
294
295 # We are searching.
296 ,,*,*)
297 TRIED="${TRIED:+$TRIED|}$hash"
298 case "$_skip" in
299 *$hash*) ;;
300 *)
301 echo "bisect_rev=$hash"
302 echo "bisect_tried=\"$TRIED\""
303 FOUND=1
304 ;;
305 esac
306 ;;
307
308 # We have already found a rev to be tested.
309 ,1,*,bisect_rev*) VARS=1 ;;
310 ,1,*,*) ;;
311
312 # ???
313 *) die "filter_skipped error " \
314 "VARS: '$VARS' " \
315 "FOUND: '$FOUND' " \
316 "TRIED: '$TRIED' " \
317 "hash: '$hash' " \
318 "line: '$line'"
319 ;;
320 esac
321 done
322}
323
324exit_if_skipped_commits () {
325 _tried=$1
326 if expr "$_tried" : ".*[|].*" > /dev/null ; then
327 echo "There are only 'skip'ped commit left to test."
328 echo "The first bad commit could be any of:"
e23cb8c0 329 echo "$_tried" | tr '[|]' '[\012]'
97e1c51e
CC
330 echo "We cannot bisect more!"
331 exit 2
332 fi
333}
334
8cc6a083 335bisect_next() {
8fe26f44 336 case "$#" in 0) ;; *) usage ;; esac
8cc6a083 337 bisect_autostart
0a5280a9
JH
338 bisect_next_check good
339
97e1c51e 340 skip=$(git for-each-ref --format='%(objectname)' \
40a7ce64 341 "refs/bisect/skip-*" | tr '\012' ' ') || exit
97e1c51e
CC
342
343 BISECT_OPT=''
344 test -n "$skip" && BISECT_OPT='--bisect-all'
345
5be60078 346 bad=$(git rev-parse --verify refs/bisect/bad) &&
0a5280a9 347 good=$(git for-each-ref --format='^%(objectname)' \
40a7ce64 348 "refs/bisect/good-*" | tr '\012' ' ') &&
97e1c51e 349 eval="git rev-list --bisect-vars $BISECT_OPT $good $bad --" &&
0a5280a9 350 eval="$eval $(cat "$GIT_DIR/BISECT_NAMES")" &&
97e1c51e 351 eval=$(filter_skipped "$eval" "$skip") &&
0a5280a9
JH
352 eval "$eval" || exit
353
354 if [ -z "$bisect_rev" ]; then
355 echo "$bad was both good and bad"
356 exit 1
670f5fe3 357 fi
0a5280a9 358 if [ "$bisect_rev" = "$bad" ]; then
97e1c51e 359 exit_if_skipped_commits "$bisect_tried"
0a5280a9 360 echo "$bisect_rev is first bad commit"
5be60078 361 git diff-tree --pretty $bisect_rev
0a5280a9 362 exit 0
8cc6a083 363 fi
0a5280a9 364
97e1c51e
CC
365 # We should exit here only if the "bad"
366 # commit is also a "skip" commit (see above).
367 exit_if_skipped_commits "$bisect_rev"
368
0a5280a9 369 echo "Bisecting: $bisect_nr revisions left to test after this"
634f2464 370 git checkout -q "$bisect_rev" || exit
5be60078 371 git show-branch "$bisect_rev"
8cc6a083
LT
372}
373
cc9f24d0
JH
374bisect_visualize() {
375 bisect_next_check fail
235997c9
JH
376
377 if test $# = 0
378 then
508e84a7 379 case "${DISPLAY+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" in
235997c9 380 '') set git log ;;
508e84a7 381 set*) set gitk ;;
235997c9
JH
382 esac
383 else
384 case "$1" in
385 git*|tig) ;;
386 -*) set git log "$@" ;;
387 *) set git "$@" ;;
388 esac
389 fi
390
e3f062bf 391 not=$(git for-each-ref --format='%(refname)' "refs/bisect/good-*")
235997c9 392 eval '"$@"' refs/bisect/bad --not $not -- $(cat "$GIT_DIR/BISECT_NAMES")
cc9f24d0
JH
393}
394
8cc6a083 395bisect_reset() {
823ea121 396 test -s "$GIT_DIR/BISECT_START" || {
fce0499f
CC
397 echo "We are not bisecting."
398 return
399 }
8cc6a083 400 case "$#" in
823ea121 401 0) branch=$(cat "$GIT_DIR/BISECT_START") ;;
737c74ee
CC
402 1) git show-ref --verify --quiet -- "refs/heads/$1" ||
403 die "$1 does not seem to be a valid branch"
8cc6a083 404 branch="$1" ;;
8fe26f44 405 *)
8cc6a083
LT
406 usage ;;
407 esac
9d0cd91c 408 git checkout "$branch" && bisect_clean_state
e204de28
JH
409}
410
38a47fd6 411bisect_clean_state() {
947a604b 412 # There may be some refs packed during bisection.
634f2464 413 git for-each-ref --format='%(refname) %(objectname)' refs/bisect/\* |
947a604b
CC
414 while read ref hash
415 do
823ea121 416 git update-ref -d $ref $hash || exit
947a604b 417 done
823ea121
CC
418 rm -f "$GIT_DIR/BISECT_LOG" &&
419 rm -f "$GIT_DIR/BISECT_NAMES" &&
420 rm -f "$GIT_DIR/BISECT_RUN" &&
9d0cd91c 421 # Cleanup head-name if it got left by an old version of git-bisect
823ea121
CC
422 rm -f "$GIT_DIR/head-name" &&
423
424 rm -f "$GIT_DIR/BISECT_START"
38a47fd6
CC
425}
426
e204de28 427bisect_replay () {
737c74ee 428 test -r "$1" || die "cannot read $1 for replaying"
e204de28 429 bisect_reset
6c98c054 430 while read git bisect command rev
e204de28 431 do
6c98c054
MV
432 test "$git $bisect" = "git bisect" -o "$git" = "git-bisect" || continue
433 if test "$git" = "git-bisect"; then
434 rev="$command"
435 command="$bisect"
436 fi
e204de28
JH
437 case "$command" in
438 start)
e9a45d75 439 cmd="bisect_start $rev"
737c74ee
CC
440 eval "$cmd" ;;
441 good|bad|skip)
442 bisect_write "$command" "$rev" ;;
e204de28 443 *)
737c74ee 444 die "?? what are you talking about?" ;;
e204de28
JH
445 esac
446 done <"$1"
447 bisect_auto_next
8cc6a083
LT
448}
449
a17c4101 450bisect_run () {
83020120
CC
451 bisect_next_check fail
452
a17c4101
CC
453 while true
454 do
455 echo "running $@"
456 "$@"
457 res=$?
458
459 # Check for really bad run error.
460 if [ $res -lt 0 -o $res -ge 128 ]; then
461 echo >&2 "bisect run failed:"
462 echo >&2 "exit code $res from '$@' is < 0 or >= 128"
463 exit $res
464 fi
465
155fc795 466 # Find current state depending on run success or failure.
71b0251c
CC
467 # A special exit code of 125 means cannot test.
468 if [ $res -eq 125 ]; then
469 state='skip'
470 elif [ $res -gt 0 ]; then
155fc795 471 state='bad'
a17c4101 472 else
155fc795 473 state='good'
a17c4101
CC
474 fi
475
155fc795
CC
476 # We have to use a subshell because "bisect_state" can exit.
477 ( bisect_state $state > "$GIT_DIR/BISECT_RUN" )
a17c4101
CC
478 res=$?
479
480 cat "$GIT_DIR/BISECT_RUN"
481
71b0251c
CC
482 if grep "first bad commit could be any of" "$GIT_DIR/BISECT_RUN" \
483 > /dev/null; then
484 echo >&2 "bisect run cannot continue any more"
485 exit $res
486 fi
487
a17c4101
CC
488 if [ $res -ne 0 ]; then
489 echo >&2 "bisect run failed:"
155fc795 490 echo >&2 "'bisect_state $state' exited with error code $res"
a17c4101
CC
491 exit $res
492 fi
493
494 if grep "is first bad commit" "$GIT_DIR/BISECT_RUN" > /dev/null; then
495 echo "bisect run success"
496 exit 0;
497 fi
498
499 done
500}
501
502
8cc6a083
LT
503case "$#" in
5040)
505 usage ;;
506*)
507 cmd="$1"
508 shift
509 case "$cmd" in
243a60fb
CC
510 help)
511 git bisect -h ;;
8cc6a083
LT
512 start)
513 bisect_start "$@" ;;
155fc795
CC
514 bad|good|skip)
515 bisect_state "$cmd" "$@" ;;
8cc6a083
LT
516 next)
517 # Not sure we want "next" at the UI level anymore.
518 bisect_next "$@" ;;
235997c9 519 visualize|view)
cc9f24d0 520 bisect_visualize "$@" ;;
8cc6a083
LT
521 reset)
522 bisect_reset "$@" ;;
e204de28
JH
523 replay)
524 bisect_replay "$@" ;;
525 log)
526 cat "$GIT_DIR/BISECT_LOG" ;;
a17c4101
CC
527 run)
528 bisect_run "$@" ;;
8cc6a083
LT
529 *)
530 usage ;;
531 esac
532esac